<?php
/**
 *                                                                                                
 */
class CRMigrator {
function run() {
global $CN_MAP_DB_SETTINGS, $CN_MAP_DBS, $FEATURE;

//                                                                      
 if ($FEATURE["contentmap_handles"]) {
//                            
 echo "ERROR: Feature contentmap_handles is activated - multiple CR configurations possible! Unable to migrate changes.";
exit(1);
} else {
//                                               
 if (!is_array($CN_MAP_DB_SETTINGS)) {
echo "CN_MAP_DB_SETTINGS is not an array - no settings found to be migrated. exiting.";
return; 
}
$crid = CRMigrator::createCR("Migrated from Configuration File", $CN_MAP_DB_SETTINGS);
echo "CR created with id {$crid}\n";

//                 
 query("UPDATE tagmap SET contentrepository_id = $crid WHERE contentrepository_id is null");
echo "updated tagmap entries\n";

//                         
 query("UPDATE node SET contentrepository_id = $crid WHERE publish_contentmap = 1");
echo "updated nodes\n";

//                
 //                                                                                  
 $rs = query("SELECT id FROM tree where type_id = 10202");
$tagmap_editor = $rs["arr"][0]["id"];
$rs = query("SELECT id FROM tree where type_id = 10207");
$contentrepositories_id = $rs["arr"][0]["id"];

if (!$tagmap_editor) {
echo "could not insert permissions, tagmap editor not found in tree!\n";
} else {
if (!$contentrepositories_id) {
//                                                
 $rs = query("INSERT INTO tree (mother, type_id, name, itemorder) SELECT id, 10207, 'ContentRepositories', 100 FROM tree WHERE type_id = 10010");
$contentrepositories_id = $rs["iid"];
}
query("INSERT INTO perm (usergroup_id, o_type, o_id, perm) SELECT usergroup_id, 10207, $contentrepositories_id, '10000000100000000000000000000000' FROM perm WHERE o_type = 10202 AND o_id = $tagmap_editor AND perm LIKE '10______________________________'");
query("INSERT INTO perm (usergroup_id, o_type, o_id, perm) SELECT usergroup_id, 10208, $crid, '10110000000000000000000000000000' FROM perm WHERE o_type = 10202 AND o_id = $tagmap_editor AND perm LIKE '10______________________________'");

//                                                                                                   
 query("INSERT INTO perm (usergroup_id, o_type, o_id, perm) SELECT usergroup_id, 10207, $contentrepositories_id, '11000000100000000000000000000000' FROM perm WHERE o_type = 10202 AND o_id = $tagmap_editor AND perm LIKE '11______________________________'");
query("INSERT INTO perm (usergroup_id, o_type, o_id, perm) SELECT usergroup_id, 10208, $crid, '11110000000000000000000000000000' FROM perm WHERE o_type = 10202 AND o_id = $tagmap_editor AND perm LIKE '11______________________________'");

echo "inserted permissions\n";
}
}
}

/**
     *                           
     */
function createCR($name, $s) {
$url = CRMigrator::transformToURL($s);
$dbtype = CRMigrator::getDBType($s);

$res = query("INSERT INTO contentrepository (name, username, password, dbtype, url)
          VALUES ('$name', '" . $s["login"] . "', '" . $s["pw"] . "', '$dbtype', '".addslashes($url)."')");
return $res["iid"];
}

/**
     *                
     *                     
     *               
     */
function getDBType($set) {
switch( $set['dbtype'] ) {
case 'mysql':
return 'mysql';
case 'ora':
return 'oracle';
default:
return $set['dbtype'];
}
}

/**
     *                                        
     *                     
     *                 
     */
function transformToURL($set) {
if( $set['jdbcurl'] ) {
return $set['jdbcurl'];
}
$db = explode(':', $set["server"]);
$url = "jdbc:".$set["dbtype"]."://".$db[0].":".($db[1] ? $db[1] : "42006")."/".$set["db"];
if( $set['jdbcparameters'] ) {
$url .= '?'.$set['jdbcparameters'];
}
return $url;
}


/**
     *                                                                        
     */
function migrateNodeConf() {
global $CONFIG_FILE;
$nodeconf = file_get_contents($CONFIG_FILE);
$pattern = '/^([\s\/]*\$CN_MAP_DB_SETTINGS.*)/m';
$PLACEHOLDER = '=====REPLACEMENT 498u5918fajsdfja49 ta8tuadvjacva948jt ====';
$DEPRECATEDTEXT = '// $CN_MAP_DB_SETTINGS was deprecated - a ContentRepository of the name \'Migrated from Configuration File\' was created.';
//                                                                                                                                  
 $nodeconf = preg_replace($pattern,$PLACEHOLDER."\n\\1", $nodeconf, 1);
$matches = array();
//                                                    
 //                                             
 //                                                 

//                             
 $nodeconf = str_replace($PLACEHOLDER, $DEPRECATEDTEXT, $nodeconf);

//                                                                                                
 file_put_contents($CONFIG_FILE, $nodeconf);
//                                        
 //                                                                                                                             
 }
}

CRMigrator::run();
CRMIgrator::migrateNodeConf();
?>
