<?php

/**
* 
*                            
* 
*                                                       
*                                               
*                                                           
* 
*                                                                                      
*                                                         
* 
**/

define ( "EVENT_DEP_ALL", 3 );
//                                       
define ( "EVENT_DEP_OTHERS", 1 );
//                                                 
define ( "EVENT_DEP_SELF", 2 );

/**
 *                                                                     
 * 
 *                                        
 *                                                    
 *                                                                              
 **/
function translateEventType($eventType, $splitter = "|", $events = null) {

if (!is_array($events)) {
$events = array();
$events[EVENT_CREATE] = "EVENT_CREATE";
$events[EVENT_UPDATE] = "EVENT_UPDATE";
$events[EVENT_DELETE] = "EVENT_DELETE";
$events[EVENT_MOVE] = "EVENT_MOVE";
$events[EVENT_CHILD] = "EVENT_CHILD";
$events[EVENT_PARENT] = "EVENT_PARENT";
$events[EVENT_NOTIFY] = "EVENT_NOTIFY";

$event = 0x80;
for ($i = 4; $i <= 12; $i++) {
$events[$event] = "EVENT_RESERVED$i";
$event *= 2;
}

$event = 0x10000;
for ($i = 1; $i <= 15; $i++) {
$events[$event] = "EVENT_USER_$i";
$event *= 2;
}

$events[EVENT_ALL] = "EVENT_ALL";
}

if ($eventType == EVENT_ALL) {
$out = $events[EVENT_ALL];
} else {
$out = "";
foreach ($events as $mask=>$name) {
if (($eventType & $mask) == $mask) {
$out .= ($out)?$splitter:"";
$out .= $name;
}
}
}

return $out;
}

/**
 *                             
 * 
 *              
 *           
 *                                                                                                                  
 *                                                                                   
 *                     
 *                                                                                                     
 *             
 **/
function removeEventDependencies( $TType, $id, $type, $linkType = false )
{
global $DEBUG;
if ($DEBUG["echo"] && $DEBUG["events"]) echo "removeEventDependencies($TType, $id, $type, $linkType);<br>\n";

if (  $linkType ) $sqlAdd = " AND link_type = ".sqlf_tl_num($linkType);
if ( $type == 1 || $type == 3 )
{
$sql = "DELETE FROM dependencymap WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." $sqlAdd";
query( $sql );//            
 }
if ( $type == 2 || $type == 3 )
{
$sql = "DELETE FROM dependencymap WHERE dep_type = ".sqlf_tl_num($TType)." AND dep_id = ".sqlf_tl_num($id)." $sqlAdd";
query( $sql );//            
 }
}

function removeEventDependency( $TType, $id, $eventTypes, $depTType, $depId, $linkType, $ignoreEvents = 0 )
{
global $DEBUG;
if ($DEBUG["echo"] && $DEBUG["events"]) {
echo "removeEventDependency($TType, $id, $eventTypes, $depTType, $depId, $linkType): ".
translateEventType($eventTypes)."; ";
if ($ignoreEvents !== false) echo "ignore: ".translateEventType($ignoreEvents)."; ";
echo "<br>\n";
}

$types = getEventDependencyEventTypes( $TType, $id, $depTType, $depId, $linkType );
$eventTypes &= $types[0]; //                                                      
 $types[0] ^= $eventTypes;
$ignoreEvents &= $types[1];
$types[1] ^= $ignoreEvents;
if ( $types[0] > 0 ) //                                
 {
$sql = "UPDATE dependencymap SET mod_event_type = ".sqlf_tl_num($types[0]).", ignore_events = ".sqlf_tl_num($types[1])." ".
"WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." ".
"AND dep_type = ".sqlf_tl_num($depTType)." AND dep_id = ".sqlf_tl_num($depId)." ".
"AND link_type = ".sqlf_tl_num($linkType);
}
else
{
$sql = "DELETE FROM dependencymap ".
"WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." ".
"AND dep_type = ".sqlf_tl_num($depTType)." AND dep_id = ".sqlf_tl_num($depId)." ".
"AND link_type = ".sqlf_tl_num($linkType);
}
query( $sql );//            
}

function addEventDependency( $TType, $id, $eventTypes, $depTType, $depId, $linkType, $ignoreEvents = 0 )
{
global $DEBUG;
if ($DEBUG["echo"] && $DEBUG["events"]) {
echo "addEventDependency($TType, $id, $eventTypes, $depTType, $depId, $linkType, $ignoreEvents): ".
translateEventType($eventTypes)."; ignore: ".translateEventType($ignoreEvents)."; <br>\n";
}

//            
 //              
 if (strlen($id) == 0) return;

$types = getEventDependencyEventTypes( $TType, $id, $depTType, $depId, $linkType, $ignoreEvents );

if ( $types[0] == $eventTypes && $types[1] == $ignoreEvents)
{
//                               
 return;
}
//                                                                    
 if ( $types[0] == 0 )
{
$sql = "INSERT INTO dependencymap ".
"( mod_type, mod_id, mod_event_type, dep_type, dep_id, link_type, ignore_events ) ".
"VALUES( ".sqlf_tl_num($TType).", ".sqlf_tl_num($id).", ".sqlf_tl_num($eventTypes).", ".sqlf_tl_num($depTType).", ".sqlf_tl_num($depId).", ".sqlf_tl_num($linkType).", ".sqlf_tl_num($ignoreEvents)." )";
}
else
{
$eventTypes |= $types[0];
$ignoreEvents &= $types[1];
$sql = "UPDATE dependencymap SET mod_event_type = ".sqlf_tl_num($eventTypes).", ignore_events = ".sqlf_tl_num($ignoreEvents)." ".
"WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." ".
"AND dep_type = ".sqlf_tl_num($depTType)." AND dep_id = ".sqlf_tl_num($depId)." ".
"AND link_type = ".sqlf_tl_num($linkType);
}
query( $sql );//            
}

/**
 *                               
 * 
 *                                                                   
 * 
 *                                                          
 * 
 *              
 *           
 *                 
 *              
 *                 
 *                                                                                                               
 **/
function getEventDependencyEventTypes( $TType, $id, $depTType, $depId, $linkType )
{

//            
 //                                           
 if (strlen($id) == 0) return array(0,0);

$sql = "SELECT mod_event_type, ignore_events FROM dependencymap WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." ".
" AND dep_type = ".sqlf_tl_num($depTType)." AND dep_id = ".sqlf_tl_num($depId)." AND link_type = ".sqlf_tl_num($linkType);
$rs = query( $sql );//            
 if ( $rs["num"] > 0 )
return array((int)$rs["arr"][0]["mod_event_type"],(int)$rs["arr"][0]["ignore_events"]);
return array(0,0);
}

/**
 *                              
 * 
 *                                                                                            
 *                                                                   
 *                                          
 * 
 *              
 *           
 *                 
 *              
 *                   
 *                                                                                             
 **/
function getEventDependencyLinkTypes( $TType, $id, $depTType, $depId, $eventTypes )
{
$sql = "SELECT link_type FROM dependencymap WHERE mod_type = ".sqlf_tl_num($TType)." AND mod_id = ".sqlf_tl_num($id)." ".
" AND dep_type = ".sqlf_tl_num($depTType)." AND dep_id = ".sqlf_tl_num($depId)." AND mod_event_type & ".sqlf_tl_num($eventTypes)." > 0 AND ignore_events & ".sqlf_tl_num($eventTypes)." = 0";
$rs = query( $sql );//            
 
$ret = array();
foreach ( $rs["arr"] as $row )
{
$ret[] = $row["link_type"];
}
return $ret;
}


function getAllEventDependencies( $TType, $id, $eventType )
{
$sql = "SELECT * FROM dependencymap ".
"WHERE mod_type=".sqlf_tl_num($TType)." AND mod_id=".sqlf_tl_num($id)." AND mod_event_type & ".sqlf_tl_num($eventType)." > 0 AND ignore_events & ".sqlf_tl_num($eventType)." = 0";
$rs = query( $sql );//            

$deps = array();
foreach ( $rs["arr"] as $row )
{
$deps[] = array( "TType"=>$row["dep_type"], "id"=>$row["dep_id"], "linkType"=>$row["link_type"] );		
}
return $deps;
}

function triggerEvent( $TType, $id, $eventType, &$eventObject, $simulate = 0 )
{
static $TIME=0;

static $DEP_CACHE = array();
static $DEPTH = 0;
static $COUNT=0;
global $DEP_MAP, $DEBUG;


if( !is_numeric($TType) || !is_numeric( $id ) || !is_numeric( $eventType ) )
{
warning( 7, "triggerEvent: Invalid TType($TType) OR id($id) OR eventType($eventType)" );
return;
}

//                          
 //                                     
 $objCacheKey = (is_object($eventObject))?$eventObject->getCacheKey():"";
if ( isset( $DEP_CACHE[$TType][$id][$eventType][$objCacheKey] ) )
return;
$DEP_CACHE[$TType][$id][$eventType][$objCacheKey] = TRUE;

//                                                                    
 if ( $DEPTH > 100 )
halt( 7, "very uneasy depth in triggerEvent ttype($TType), id($id), eventType($eventType)" );

$DEPTH ++;

//                                                       
 if ( $DEBUG["echo"] && $DEBUG["events"] )
{
$COUNT++;
$prefix = str_repeat("---|", $DEPTH-1);
echo "$prefix<b>TRIGGERED (nr. $COUNT)</b>: T_Type($TType) id($id) eventType($eventType) DEPTH($DEPTH): ".
translateEventType($eventType).";<br />\n";
}	
//                   
 if ( $DEBUG["echo"] && $DEBUG["events"] )
echo "<br />$prefix STATICS:<br />========<br />";

if ( is_array( $DEP_MAP[$TType] ) )
{
//                                                           
 foreach ( $DEP_MAP[$TType] as $eType => $depTypes )
{
//                                            
 if ( ($eType & $eventType) > 0 )
{	  
foreach ( $depTypes as $depType )
{
node_class("nodefactory");
$nodeClass = NodeFactory::getInstanceOf( $depType );
if ( $nodeClass !== NULL )
{
if ( $DEBUG["echo"] && $DEBUG["events"] )
echo "$prefix NOTIFYING: $depType per ".get_class($nodeClass)."<br />---------------------<br />";
$nodeClass->onStaticEventNotify( $TType, $id, $eventType, $eventObject, $DEPTH, $simulate );
}
else if ( $DEBUG["echo"] && $DEBUG["events"] )
{
echo "$prefix WARNING: no instance found for ($depType)<br />";
}
}
}
}
}

//                    
 if ( $DEBUG["echo"] && $DEBUG["events"] )
echo "<br />$prefix DYNAMICS:<br />========<br />";
$deps = getAllEventDependencies( $TType, $id, $eventType );
foreach ( $deps as $dep )
{
//                                    
 $nodeClass = NodeFactory::getInstanceOf( $dep["TType"], $dep["id"] );
if ( $nodeClass !== NULL )
{
if ( $DEBUG["echo"] && $DEBUG["events"] )
echo "$prefix NOTIFYING: $dep[TType] / $dep[id] per ".get_class($nodeClass)."<br />---------------------<br />";

$nodeClass->onEventNotify( $TType, $id, $eventType, $dep["linkType"], $eventObject, $DEPTH, $simulate );
}
else 
{
if ( $DEBUG["echo"] && $DEBUG["events"] )
echo "$prefix WARNING: no instance found for ($depType)<br />";

BaseObject::addDebugMessage("triggerEvent: no instance found for Type(".$dep["TType"].")");
}
}

//                     
 ///                                                                              

$DEPTH --;
}

?>
