<?

class SkeletonLoader extends BaseObject {

var $d_skelPath;
var $d_skeletons;

function SkeletonLoader($dir = "") {
global $FILEPATH, $SKELETONPATH;
if ($dir) {
$this->d_skelPath = $dir;
} else if ($SKELETONPATH) {
$this->d_skelPath = $SKELETONPATH;
} else {
$this->d_skelPath = "$FILEPATH/skeleton";
}
if (!is_dir($this->d_skelPath)) halt(7, "SkeletonLoader: '".$this->d_skelPath."' is not a valid directory.");
$this->reloadSkeletons();
}

function reloadSkeletons() {
$exclude = array(".", "..", "CVS");

$this->d_skeletons = array();

$d = dir($this->d_skelPath);
while ($entry = $d->read()) {
if (!is_dir($this->d_skelPath."/".$entry) || in_array($entry, $exclude)) continue;
$this->d_skeletons[$entry] = false;
}
$d->close();
}

function getSkeletons() {
return $this->d_skeletons;
}

function _assignVarsRek( $iniVals, &$dest )
{
if ( is_array( $iniVals ) )
{
foreach ( $iniVals as $iniKey=>$iniVal )
{
if ( !is_array( $iniVal ) )
{
if ( !isset( $dest[$iniKey] ) )
$dest[$iniKey] = $iniVal;
}
else
{
if ( !is_array( $dest[$iniKey] ) ) $dest[$iniKey] = array();
$this->_assignVarsRek( $iniVal, $dest[$iniKey] );
}
}
}
}

function loadSkeleton($skel) {
if (!isset($this->d_skeletons[$skel])) return false;
$this->d_skeletons[$skel]["ini"] = array();
$_skel = $skel;
do {
$default_skel = $_skel == "default";
$inifile = $this->d_skelPath."/$_skel/config.ini";
if (file_exists($inifile)) {
node_class("inifile");
$ini = new IniFile($inifile);
$iniVals = $ini->getSectionValues();

$this->_assignVarsRek( $iniVals, $this->d_skeletons[$skel]["ini"] );
$_skel = $this->inheritsFrom( $_skel );
}
} while ( !$default_skel );
}

function inheritsFrom($skel) {
$skel = $this->getSkeleton($skel);
if ($inherits = $this->d_skeletons[$skel]["ini"]["skeleton"]["inherits"]) {
return isset($this->d_skeletons[$inherits])?$inherits:"default";
} else return "default";
}

function getSkeleton($skel) {
if (!isset($this->d_skeletons[$skel])) $skel = "default";
if ($this->d_skeletons[$skel] === false) $this->loadSkeleton($skel);
return $skel;
}

function getTemplate($skel, $template) {
$skel = $this->getSkeleton($skel);
if (($html = $this->d_skeletons[$skel]["templates"][$template]) !== NULL ) return $html;

$tpl = str_replace(".","/",$template).".skel";
$_skel = $skel;
$inherits = array();
$default_skel = false;
do {
$default_skel = $_skel == "default";
$file = $this->d_skelPath."/$_skel/$tpl";
if (file_exists($file)) {
$html = implode("",file($file));
$info = $this->getTemplateInfo($skel, $template);
foreach ($info as $name=>$value) {
if (strtolower(substr($name, 0, 6)) != "value.") continue;
$html = str_replace("<skel $name>", $value, $html);
}
$html = str_replace( array("\\n"), "\n", $html );
$this->d_skeletons[$skel]["templates"][$template] = $html;
return $html;
}
$_skel = $this->inheritsFrom($_skel);
if ($inherits[$_skel]) break;
$inherits[$_skel] = true;
} while (!$default_skel);
return "";
}

function getTemplateInfo($skel, $template) {
$skel = $this->getSkeleton($skel);
$rs = array();
if ($this->d_skeletons[$skel]["ini"][$template]) {
$rs += $this->d_skeletons[$skel]["ini"][$template];
}
return $rs;
}

function getParentTemplate($skel, $template) {
$parts = explode(".",$template);
$parent = "";
for ($i = 0; $i < count($parts) - 1; $i++) {
if ($parent) $parent .= ".";
$parent .= $parts[$i];
}
return $parent;
}

}

?>
