<?php
/**
 *                                  
 *                                         
 *                                  //                    /            
 *                        
 *                                       
 *                                             
 *                                            
 * 
 *                               
 *                                                             
 *                          //          /       
 * 
 */

//              
//                                   /     
//                                    
//                       

$request = array(
'method'   => $_SERVER['REQUEST_METHOD'],
'protocol' => $_SERVER['SERVER_PROTOCOL'],
'headers'  => getallheaders(),
//               /                                //            
 //                                                                
 //                  
 'payload'  => file_get_contents('php://input'),
);

//                   
if (array_key_exists('url', $_GET)) {
$request['url'] = urldecode($_GET['url']);
if(!checkWhitelist($request)) {
echo "Gentics AJAX Gateway failed because url did not pass the whitelist.";
exit();
}
} else {
header("HTTP/1.0 400 Bad Request");
echo "Gentics AJAX Gateway failed because parameter url is missing.";
exit();
}

//                     
$response = http_request($request);

//                                                    
//                                                     
if (strtoupper($method) == 'HEAD' && (int)$response['status'] >= 400 ) {

$request['method'] = 'GET';
$response = http_request($request);

//                                                           
 fclose($response['socket']);
$response['socket'] = null;
}

//                                
foreach ($response['headers'] as $key => $value) {
if (strtolower($key) == 'content-length') {
//                                                                   
 //                                                                     
 //                                      
 //                                                        
 //                                          
 continue;
}
header("$key: $value");
}

header('Connection: close');

//                           
if (null !== $response['socket']) {
fpassthru($response['socket']);
fclose($response['socket']);
}

exit;

/**
 *                                                           
 */
function checkWhitelist($request) {
global $SETTINGS;
foreach ($SETTINGS['proxy_whitelist'] as $value) {
if(preg_match($value,$request['url'])) {
return true;
}
}
return false;
}

/**
 *                                                                      
 *                                                                     
 *                                                                      
 *                                                   
 *                            
 *                                                                 
 *                                                       
 */
function http_request($request, $timeout = 5) {

$url = $request['url'];
//                              
 $parts = parse_url($url);
if (array_key_exists('host', $parts)) {
$remote = $parts['host'];
} else {
return myErrorHandler("url ($url) has no host. Is it relative?");
}
if (array_key_exists('port', $parts)) {
$port = $parts['port'];
} else {
$port = 0;
}

//                          /                                                        
 $request_headers = "";
foreach ($request['headers'] as $name => $value) {
switch (strtolower($name)) {
//                 
 case "keep-alive":
case "connection":
case "cookie":
//                                                            
 //                                                            
 //                        /                               
 //                                                              
 //                                                            
 //                             
 case "accept-encoding":
break;
//                           
 case "host":
$host_info = $remote;
if ($port) {
$host_info .= ':' . $port;
}
$request_headers .= "$name: $host_info\r\n";
break;
//                          
 default:
$request_headers .= "$name: $value\r\n";
break;
}
}

//                                                    
 switch (strtolower($parts['scheme'])) {
case 'https':
$scheme = 'ssl://';
if ( ! $port ) $port = 443;
break;
case 'http':
$scheme = '';
if ( ! $port ) $port = 80;
break;
default:
//                                                            
 //                     //       /      /  /                   
 $scheme = $parts['scheme'] . '://';
if ( ! $port ) {
return myErrorHandler("Unknown scheme ($scheme) and no port.");
}
break;
}

//                                                                 
 //                                                                 
 //                                 
 $sock = @fsockopen("$scheme$remote", $port, $errno, $errstr, $timeout);
if ( ! $sock ) {
return myErrorHandler("Unable to open URL ($url): $errstr");
}

//                                                                  
 //                          
 stream_set_timeout($sock, $timeout);

//                                                           
 if (array_key_exists('path', $parts)) {
$path_info  = $parts['path'];
} else {
$path_info  = '/';
}

if (array_key_exists('query',    $parts)) $path_info .= '?' . $parts['query'];
if (array_key_exists('fragment', $parts)) $path_info .= '#' . $parts['fragment'];

$out = $request["method"]." ".$path_info." ".$request["protocol"]."\r\n"
. $request_headers
. "Connection: close\r\n\r\n";
fwrite($sock, $out);
fwrite($sock, $request['payload']);

$header_str = stream_get_line($sock, 1024*16, "\r\n\r\n");
$headers = http_parse_headers($header_str);
$status_line = array_shift($headers);

//                
 preg_match('|HTTP/\d+\.\d+\s+(\d+)\s+.*|i',$status_line,$match);
$status = $match[1];

return array('headers' => $headers, 'socket' => $sock, 'status' => $status);
}

/**
 *                                                                    
 *                  
 *                                 
 */
function http_parse_headers($header_str) {
$headers = array();

//                          
 $header_str = preg_replace("/^(?:\x0D?\x0A)+/", '', $header_str);

while (preg_match("/^([^\x0A]*?)\x0D?(?:\x0A|\$)/", $header_str, $matches)) {
$header_str = substr($header_str, strlen($matches[0]));
$status_line = $matches[1];

if (empty($headers)) {
//                
 $headers[] = $status_line;
}
elseif (preg_match('/^([^:\s]+)\s*:\s*(.*)/', $status_line, $matches)) {
if (isset($key)) {
//                                                        
 $headers[$key] = $val;
}
list(,$key,$val) = $matches;
}
elseif (preg_match('/^\s+(.*)/', $status_line, $matches)) {
//                            
 $val .= " ".$matches[1];
}
else {
//                                                                
 break;
}
}
if (isset($key)) {
$headers[$key] = $val;
}
return $headers;
}

function myErrorHandler($msg)
{
//                            
 //                                                            
 header("HTTP/1.0 500 Internal Error");
echo "Gentics Aloha Editor AJAX Gateway Error: $msg";
exit();
}

//   
