<?

class CNObjectParser extends NodeObjectParser {

function CNObjectParser() {
parent::NodeObjectParser();
}
}

/**
 *                          
 **/
class CNTagObjectParser extends CNObjectParser {

function CNTagObjectParser() {
parent::CNObjectParser();
}

function _parse($code, $props) {

$tagname = $this->getKeyname();
$part = ($props["prop"])?$props["prop"]:false;

$obj =& $this->getBaseObject();
$tag =& $obj->getTag($tagname);
$tagParser =& $this->_getTagBuilder();
$tagParser->setMlID($obj->getMlID());
$parts = $tagParser->buildTagParts($tag, $obj, $code);
$ret = new CNTagString($parts, $tag->getIcon(), $part, $props["format"]);

return $ret;
}

function keyExists() {
$obj =& $this->getBaseObject();
if (!is_a($obj,"cntagcollection")) return false;
$tag =& $obj->getTag($this->getKeyname());
if (!is_a($tag, "cntagobject")) return false;
return true;
}

//                      
 function useCache() {
return false;
}

function getCacheKey() {
$obj =& $this->getBaseObject();
$tag =& $obj->getTag($this->getKeyname());
if (!is_object($tag)) return false;
return array($tag->getTagType(), $tag->getID());
}

function &_getTagBuilder() {
static $tagbuilder;
if (!is_object($tagbuilder)) {
$tagbuilder = new CNTagBuilder();
}
return $tagbuilder;
}

}

class CNPropertyObjectParser extends CNObjectParser {

function CNPropertyObjectParser() {
parent::CNObjectParser();
}

function getProperties() {
return array("seite"=>true, "ordner"=>true, "node"=>true);
}

function _parse($code, $props) {

$key = strtolower($this->getKeyname());
$prop = strtolower($props["prop"]);

if ($key == "seite") {
$page =& $this->getBaseObject();
if (!is_a($page, "cnpageobject")) return new ParserMessage(i18n("Property {0} not available.",0,$key.".".$prop));
switch ($prop) {
case "veroeffentlichungstimestamp":
$ts = $page->getProperty("publishtime");
$obj = new IntObject($ts->getTimestamp());
break;
default:
$obj = $page->getProperty($prop);
}
} else if ($key == "ordner") {
$bobj =& $this->getBaseObject();
$folder = $bobj->getProperty("folder");
if (!is_a($folder,"cnfolderobject")) return new ParserMessage(i18n("Property {0} not available.",0,$key.".".$prop));

switch ($prop) {
default: 
$obj = $folder->getProperty($prop);
}
} else if ($key == "node") {
$bobj =& $this->getBaseObject();
$node = $bobj->getProperty("node");
if (!is_a($node,"cnnodeobject")) return new ParserMessage(i18n("Property {0} not available.",0,$key.".".$prop));

switch ($prop) {
default: 
$obj = $node->getProperty($prop);
}
}

if (is_array($props["format"]) && !is_a($obj, "emessage")) {
$obj = new StringObject( CNTagString::handleFormat($obj->toString(), $props["format"] ) );
}

return $obj;
}

function keyExists() {
return in_array(strtolower($this->getKeyname()), $this->getProperties());
}
}

/**
 *                                                                                                                              
 **/
class CNTagString extends BaseObject {

var $icon;
var $parts;
var $part;
var $format;

function CNTagString($parts, $icon = "", $part = false, $format = false) {
$this->icon = $icon;
$this->parts = $parts;
$this->part = $part;
$this->format = $format;
}

function getIconCode() {
///                    
 return img($this->icon);
}

function getHtml(&$baseObj, $editMode) {
$html = $this->parts->buildPartCode($baseObj, $editMode, $this->part);
$ret = $this->handleFormat($html, $this->format);
return $ret;
}

function toString() {
return $this->getHtml(CN_EM_PUBLISH);
}

function handleFormat($code, $format) {
if (!is_array($format) || count($format) == 0) return $code;

if (in_array("escape",$format)) $code = addslashes($code);

return $code;
}
}

?>
