<?

/***
                                        /                  
                              
 ***/


/**
 *                                                                                                                                 
 */
function get_latest_version() {
return parse_version(get_latest_updatefilename());
}

/**
 *                                                      
 */
function get_current_gcnversion() {
$r = query("SELECT textvalue FROM nodesetup WHERE name = 'version'");
return parse_version($r['arr'][0]['textvalue']);
}

/**
 *                                   
 */
function get_latest_updatefilename() {
$sql = "select textvalue from nodesetup where name = 'latest_gcnversion'";
$rs = query( $sql );//            
$info = $rs['arr'][0]['textvalue'];
list($lastcheck, $file) = split(';', $info);
return $file;
}

/**
 *                                                                                                                   
 * 
 *           //        /    /  /                           #                                            
 
 *                                                                                                                    /    
 *                                                                               
 *                         
 *                                                       
 *                                     
 *                                                    
 *       
 *               //                     
 *               //                     
 *               //            
 *                             //              /           
 *              //                                         
 *   
 */
function parse_version($string) {
preg_match("/(\d)\.(\d{1,2})\.(\d{1,2})(-(\d+\.?\d+)-(\d+))?/", $string, $m);
return array(
'major' => $m[1],
'minor' => $m[2],
'patch' => $m[3],
'build' => $m[5],
'count' => $m[6]
);
}

/**
 *                                                                                                       
 */
function checkforupdates() {
global $log, $SELFUPDATE_BASEURL, $STAG, $DO, $availableupdates, $TIME, $UPDATE_POLICY, $UPDATE_FROM_LOCAL;
if ($UPDATE_FROM_LOCAL) {
$filename = checkforlocalupdates();
} else {
$params = selfupdate_get_params();
if (!$UPDATE_POLICY) {
$UPDATE_POLICY = 'released';
}

//                                                        
$contents = file_get_contents("$SELFUPDATE_BASEURL/$UPDATE_POLICY.txt$params");
if (!$contents) {
return false;
}
$filename = trim($contents);
$log .= "contents: <pre>$contents</pre>";
}
$version = parse_version($filename);

$sql = "delete from nodesetup where name = 'latest_gcnversion'";
query($sql);//            
$sql = "insert into nodesetup (name, textvalue) values ('latest_gcnversion', '".sqlf_escaped("$TIME;$filename")."')";
query($sql);//            

return $filename;
}

/**
 *                                                                     
 */
function checkforlocalupdates() {
global $UPDATE_FROM_LOCAL, $TIME, $log;

//                                      
$files = scandir($UPDATE_FROM_LOCAL);
$highestversion = array();
$highestfilename = false;
foreach( $files as $file ) {
//                                                       
$version = parse_version($file);
//                                               
if (compare_gcnversion($version, $highestversion) > 0) {
$highestfilename = $file;
$highestversion = $version;
}
}
return $highestfilename;
}

function selfupdate_get_params() {
global $MAJORMINORVERSION;
return "?sn=" . get_license_key() . "&hw=" . get_hardware_checksum() . "&build=" . get_current_gcnversion() . "&product=CN&version=$MAJORMINORVERSION";
}

/**
 *                                
 *                       
 * 
 *       
 *              
 *              
 *              
 *                            
 *   
 * 
 *                                     
 *                                      
 *                                                         
 */
function compare_gcnversion($v1, $v2) {
$vParts = array('major', 'minor', 'patch', 'build', 'count');

//                                                                 
//                       
if (!$v1['build']) {
$v1['build'] = 99999999;
$v1['count'] = 999;
}
if (!$v2['build']) {
$v2['build'] = 99999999;
$v2['count'] = 999;
}	

while (list($k, $p) = each($vParts)) {
//                                                 
if ($v1[$p] > $v2[$p]) {
return 1;
} else if ($v1[$p] < $v2[$p]) {
return -1;
}
}

//                    
return 0;
}

/**
 *                                                                   
 */
function prettyprint_gcnversion($v) {
if (!$v['major']) {
return i18n('Unknown');
}

$ver = $v['major'] . '.' . $v['minor'] . '.' . $v['patch'];
if ($v['build']) {
$ver .= ', Build ' . $v['build'] . '-' . $v['count'];
}
return $ver;
}

?>